unit TADRAT;


{****************   partea de interfata - este accesibila din exterior ********************}
INTERFACE

type TRational=record
        numa,numi:integer;
     end;

function RationalCreare(na,ni:integer;var r:TRational):boolean;
function RationalSelNumarator(r:TRational):integer;
function RationalSelNumitor(r:TRational):integer;
function RationalSetNumarator(na:integer;var r:TRational):boolean;
function RationalSetNumitor(ni:integer;var r:TRational):boolean;

function RationalLaIntreg(r:TRational;var n:integer):boolean;
function RationalCompara(r1,r2:TRational):integer;
procedure RationalAdunare(r1,r2:TRational;var rs:TRational);

procedure RationalLaString(r:TRational;var s:string);
function RationalDinString(s:string;var r:TRational):boolean;
{****************   partea de implementare - Nu este accesibila din exterior ********************}
IMPLEMENTATION
procedure Simplificare(var r:TRational);
var x,y:integer;
begin
   x:=r.numa;
   y:=r.numi;

   while(x<>y) do
    if(x>y)then
       x:=x-y
    else
       y:=y-x;
   r.numa:=r.numa div x;
   r.numi:=r.numi div x;
end;


procedure RationalCreareOk(na,ni:integer;var r:TRational);
begin
    r.numa:=na;
    r.numi:=ni;
    If (ni<0) then r.numa:=-r.numa;
    Simplificare(r);
end;

function RationalCreare(na,ni:integer;var r:TRational):boolean;
var corect:boolean;
begin
        corect:=true;
        if ni=0 then corect:=false
        else
           RationalCreareOk(na,ni,r);
        RationalCreare:=corect;
end;

function RationalSelNumarator(r:TRational):integer;
begin
    RationalSelNumarator:=r.numa;
end;
function RationalSelNumitor(r:TRational):integer;
begin
    RationalSelNumitor:=r.numi;
end;
function RationalSetNumarator(na:integer;var r:TRational):boolean;
var corect:boolean;
begin
    corect:=true;
    r.numa:=na;
    Simplificare(r);
    RationalSetNumarator:=corect;
end;

function RationalSetNumitor(ni:integer;var r:TRational):boolean;
var corect:boolean;
begin
    corect:=true;
    if(ni=0) then corect:=false
    else
      begin
        r.numi:=ni;
        if(r.numi<0) then r.numa:=-r.numa;
        Simplificare(r);
      end;
    RationalSetNumitor:=corect;
end;

function RationalLaIntreg(r:TRational;var n:integer):boolean;
var corect:boolean;
begin
     corect:=true;
     if(r.numi<>1)then corect:=false
     else
       n:=r.numa;
     RationalLaIntreg:=corect;

end;
function RationalCompara(r1,r2:TRational):integer;
var r1Nou,r2Nou:TRational;
    rez:integer;
begin
  RationalCreareOk(r1.numa*r2.numi,r1.numi*r2.numi,r1Nou);
  RationalCreareOk(r2.numa*r1.numi,r1.numi*r2.numi,r2Nou);
  if(r1Nou.numa<r2Nou.numa) then
     rez:=-1
  else
    if(r1Nou.numa=r2Nou.numa) then
       rez:=0
    else
      if(r1Nou.numa>r2Nou.numa) then
        rez:=1;
  RationalCompara:=rez;
end;
procedure RationalAdunare(r1,r2:TRational;var rs:TRational);
begin
    rs.numa:=r1.numa*r2.numi+r1.numi*r2.numa;
    rs.numi:=r1.numi*r2.numi;
    Simplificare(rs);
end;
procedure RationalLaString(r:TRational;var s:string);
var numa,numi:string;
begin
  str(r.numa,numa);
  str(r.numi,numi);
  s:=numa+'/'+numi;
end;
function RationalDinString(s:string;var r:TRational):boolean;
var p,cifra,codDeEroare,numa,numi:integer;
    corect:boolean;
begin
  p:=1;
  numa:=0;
  corect:=true;
  while(s[p]<>' ')and(p<=length(s)) and (corect) do
    begin
     val(s[p],cifra,codDeEroare);
     if(codDeEroare>0) then
       corect:=false
     else
      begin
         numa:=numa*10+cifra;
         p:=p+1;
      end;
    end;
  numi:=0;
  p:=p+1;
  while(s[p]<>' ')and(p<=length(s)) and(corect)do
    begin
     val(s[p],cifra,codDeEroare);
     if(codDeEroare>0) then
       corect:=false
     else
       begin
         numi:=numi*10+cifra;
         p:=p+1;
       end;
    end;
  if (corect) then
      corect:=RationalCreare(numa,numi,r);
  RationalDinString:=corect;
end;


END
.
